<?php
define('URL','https://t.geekdata.com/dgt.fcgi');

class SjkService {
    private $serviceurl = URL;
    private $platform;
    private $dataStr = '';
    private $cookie;

    private $dataSchema = array(
        "a" => "appKey",
        "b" => "firstPartyCookie",
        "c" => "sessionId",
        "e" => "eventType",
        "f" => "currentUrl",
        "g" => "onlineTimes",
        "i" => "visitorType",
        "j" => "visitorLocaltime",
        "k" => "appChannel",
        "l" => "deviceType",
        "m" => "deviceName",
        "n" => "deviceBrand",
        "o" => "os",
        "p" => "osVersion",
        "q" => "appVersion",
        "r" => "ua",
        "s" => "resolution",
        "t" => "cookiePlugin",
        "u" => "network",
        "v" => "directorPlugin",
        "w" => "flashPlugin",
        "x" => "gearsPlugin",
        "y" => "javaPlugin",
        "z" => "pdfPlugin",
        "aa" => "quicktimePlugin",
        "ab" => "realplayerPlugin",
        "ac" => "silverlightPlugin",
        "ad" => "windowsmediaPlugin",
        "af" => "loadTime",
        "ag" => "tag_elem",
        "ah" => "dmd",
        "ai" => "dsh",
        "ak" => "ccp",
        "al" => "longitude",
        "am" => "latitude",
        "an" => "tag_position",
        "ao" => "frequency",
        "ap" => "userId",
        "aq" => "userRegisterUrl",
        "ar" => "userGender",
        "as" => "userAge",
        "at" => "userType",
        "au" => "userLevel",
        "av" => "userProvince",
        "aw" => "userCity",
        "ax" => "browserEngine",
        "ay" => "browserName",
        "az" => "browserVersion",
        "ba" => "language",
        "bb" => "registerTime",
        "bc" => "registerRegion",
        "bd" => "innerReferUrl",
        "be" => "firstReferUrl",
        "bf" => "window_width",
        "bg" => "window_height",
        "bh" => "page_height",
        "bi" => "browse_height",
        "bj" => "firstAccessTime",
        "bl" => "utm",
        "bm" => "trailtime",
        "bn" => "formtag",
        "bo" => "formeltag",
        "bp" => "formel_time",
        "bq" => "formel_fre",
        "br" => "form_time",
        "bs" => "form_ablist",
        "bt" => "tag-class",
        "bu" => "product_id",
        "bv" => "product_price",
        "bw" => "discountprice",
        "bx" => "productcount",
        "by" => "orderid",
        "bz" => "orderprice",
        "ca" => "discountorderprice",
        "cb" => "freight",
        "cd" => "unitprice",
        "ce" => "discountunitprice",
        "cf" => "discountsku",
        "cg" => "discountspu",
        "ch" => "first_class",
        "ci" => "second_class",
        "cj" => "third_class",
        "ck" => "error_msg",
        "cl" => "record_key",
        "cm" => "recording"
   );

    public function __construct() {
    }

    /**
     * @return unknown
     */
    public function getServiceLog() {
        return $this->dataStr;
    }

    public function setCookie($cookie){
        $this->cookie = $cookie;
    }

    public function postEvent($data, $ipaddr, $platform) {

        if(!preg_match('/^((25[0-5]|2[0-4]\\d|[1]{1}\\d{1}\\d{1}|[1-9]{1}\\d{1}|\\d{1})($|(?!\\.$)\\.)){4}$/',$ipaddr)) {
            $return = array(
                'status' => false,
                'msg'  => 'ip地址格式错误'
           );
            return json_encode($return);
        }
        if(!in_array($platform,array(1,2,3,4,5))){
            $this->platform = 1;
        }else{
            $this->platform = $platform;
        }

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $this->serviceurl.'?tp='.$this->platform);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);

        $this->formatData($data);//组装数据
        $gzData = gzencode($this->dataStr);//压缩数据

        $header = array(
            'Content-Type: text/plain;',
            'charset=utf-8;',
            'Sjk-Forward-Ip: '.$ipaddr
       );

        curl_setopt($ch, CURLOPT_POSTFIELDS, $gzData);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); //不加会报证书问题
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); //不加会报证书问题
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);

        $ret = curl_exec($ch);

        if(!empty($ret)){
            $return = array(
                'status' => false,
                'msg'  => $ret
           );
        }else{
            $return = array(
                'status' => true,
                'msg'  => 'success'
           );
        }

        curl_close($ch);
        return json_encode($return);
    }

    /**
     * @return unknown
     */
    private function formatData($data) {
        //解析cookie，设置对应字段
        if($this->cookie){
            $this->processCookie($data);
        }
        //标准字段
        foreach($this->dataSchema as $key => $name) {
            $value = $data[$name] ? trim($data[$name]) : '';
         $resultArr [$key] = $key.'='.$value;
      }
      //自定义字段
        $standardKeys = array_values($this->dataSchema);
        $userKeys = array_keys($data);
        $customKeys = array_diff($userKeys,$standardKeys);//在user但是不在standard中的字段
        foreach($customKeys as $name) {
            $value = $data[$name] ? trim($data[$name]) : '';
            $resultArr [$name] = $name . '=' . $value;
        }
        if(!$resultArr['a'] || $resultArr['a'] == 'a=') {
            $return = array(
                'status' => false,
                'msg'  => '缺少appKey'
           );
            echo json_encode($return);
	    die();
        }
        if(!$resultArr['b'] || $resultArr['b'] == 'b=') {
            $resultArr['b'] = 'b=0000000000000000';
        }
        if(!$resultArr['e'] || $resultArr['e'] == 'e=') {
            $return = array(
                'status' => false,
                'msg'  => '缺少事件类型e'
           );
            echo json_encode($return);
	    die();
        }

        $this->dataStr = implode('&',array_values($resultArr));
    }

    private function processCookie(&$data)
    {
        $cookieArr = explode('|||',$this->cookie);
        if(count($cookieArr) != 11) return;
        if(!empty($cookieArr[0]) && $cookieArr[0] != 'undefined' && empty($data['firstPartyCookie'])){
            $data['firstPartyCookie'] = $cookieArr[0];
        }
        if(!empty($cookieArr[2]) && $cookieArr[2] != 'undefined' && empty($data['frequency'])){
            $data['frequency'] = $cookieArr[2];
        }
        if(!empty($cookieArr[3]) && $cookieArr[3] != 'undefined' && empty($data['visitorLocaltime'])){
            $data['visitorLocaltime'] = $cookieArr[3];
        }
        if(!empty($cookieArr[6]) && $cookieArr[6] != 'undefined' && empty($data['sessionId'])){
            $data['sessionId'] = $cookieArr[6];
        }
        if(!empty($cookieArr[7]) && $cookieArr[7] != 'undefined' && empty($data['appChannel'])){
            $data['appChannel'] = urlencode($cookieArr[7]);
        }
        if(!empty($cookieArr[8]) && $cookieArr[8] != 'undefined' && empty($data['firstReferUrl'])){
            $data['firstReferUrl'] = urlencode($cookieArr[8]);
        }
        if(!empty($cookieArr[9]) && $cookieArr[9] != 'undefined' && empty($data['visitorType'])){
            $data['visitorType'] = $cookieArr[9];
        }
        if(!empty($cookieArr[10]) && $cookieArr[10] != 'undefined' && empty($data['utm'])){
            $utmArr = json_decode($cookieArr[10],true);
            foreach($utmArr as $k=>$v){
                if($v == '') continue;
                $utmData[] = $k.'='.$v;
            }
            $data['utm'] = urlencode(implode('&',$utmData));
        }
    }
}

?>
